HTTP_ATTR, HTTPS_ATTR = 'HTTP', 'HTTPS'

ASSUMES_ROLE_SESSION_NAME = 'modular'

MODULAR_AWS_ACCESS_KEY_ID_ENV = 'modular_aws_access_key_id'
MODULAR_AWS_SECRET_ACCESS_KEY_ENV = 'modular_aws_secret_access_key'
MODULAR_AWS_SESSION_TOKEN_ENV = 'modular_aws_session_token'
MODULAR_AWS_CREDENTIALS_EXPIRATION_ENV = 'modular_aws_credentials_expiration'

REGION_ENV = 'AWS_REGION'
DEFAULT_REGION_ENV = 'AWS_DEFAULT_REGION'
MODULAR_REGION_ENV = 'MODULAR_AWS_REGION'

MODULAR_SERVICE_MODE_ENV = 'modular_service_mode'
SERVICE_MODE_DOCKER = 'docker'
SERVICE_MODE_SAAS = 'saas'

PARAM_MONGO_USER = 'modular_mongo_user'
PARAM_MONGO_PASSWORD = 'modular_mongo_password'
PARAM_MONGO_URL = 'modular_mongo_url'
PARAM_MONGO_DB_NAME = 'modular_mongo_db_name'
PARAM_ASSUME_ROLE_ARN = 'modular_assume_role_arn'

ENV_INNER_CACHE_TTL_SECONDS = 'INNER_CACHE_TTL_SECONDS'
DEFAULT_INNER_CACHE_TTL_SECONDS: int = 600

# Parent types
AWS_ATHENA = 'AWS_ATHENA'
AZURE_AD_SSO = 'AZURE_AD_SSO'
GCP_SECURITY = 'GCP_SECURITY'
AWS_MANAGEMENT = 'AWS_MANAGEMENT'
GCP_MANAGEMENT = 'GCP_MANAGEMENT'
AZURE_RATE_CARDS = 'AZURE_RATE_CARDS'
AZURE_MANAGEMENT = 'AZURE_MANAGEMENT'
AWS_COST_EXPLORER = 'AWS_COST_EXPLORER'
AZURE_CSP_BILLING = 'AZURE_CSP_BILLING'
AZURE_CSP_PARTNER = 'AZURE_CSP_PARTNER'
AZURE_USAGE_DETAILS = 'AZURE_USAGE_DETAILS'
GCP_BILLING_SERVICE = 'GCP_BILLING_SERVICE'
AZURE_ENTERPRISE_BILLING = 'AZURE_ENTERPRISE_BILLING'
CUSTODIAN_TYPE = 'CUSTODIAN'
CUSTODIAN_ACCESS_TYPE = 'CUSTODIAN_ACCESS'
CUSTODIAN_LICENSES_TYPE = 'CUSTODIAN_LICENSES'
RIGHTSIZER_PARENT_TYPE = 'RIGHTSIZER'
RIGHTSIZER_LICENSES_PARENT_TYPE = 'RIGHTSIZER_LICENSES'
SIEM_DEFECT_DOJO_TYPE = 'SIEM_DEFECT_DOJO'
ALL_PARENT_TYPES = [
    AWS_MANAGEMENT, AWS_ATHENA, AWS_COST_EXPLORER,
    AZURE_ENTERPRISE_BILLING, AZURE_USAGE_DETAILS,
    AZURE_RATE_CARDS, AZURE_CSP_BILLING, AZURE_CSP_PARTNER,
    AZURE_MANAGEMENT, AZURE_AD_SSO, GCP_BILLING_SERVICE,
    GCP_SECURITY, GCP_MANAGEMENT, CUSTODIAN_TYPE,
    RIGHTSIZER_PARENT_TYPE, RIGHTSIZER_LICENSES_PARENT_TYPE,
    SIEM_DEFECT_DOJO_TYPE, CUSTODIAN_LICENSES_TYPE
]

AZURE_CLOUD = 'AZURE'
YANDEX_CLOUD = 'YANDEX'
GOOGLE_CLOUD = 'GOOGLE'
AWS_CLOUD = 'AWS'
OPENSTACK_CLOUD = 'OPEN_STACK'
CSA_CLOUD = 'CSA'
HWU_CLOUD = 'HARDWARE'
ENTERPRISE_CLOUD = 'ENTERPRISE'
EXOSCALE_CLOUD = 'EXOSCALE'
WORKSPACE_CLOUD = 'WORKSPACE'
AOS_CLOUD = 'AOS'
VSPHERE_CLOUD = 'VSPHERE'
VMWARE_CLOUD = 'VMWARE'  # VCloudDirector group
NUTANIX_CLOUD = 'NUTANIX'

CLOUD_SHORT_LONG_NAME_MAPPING = {
    AZURE_CLOUD: 'AZ',
    GOOGLE_CLOUD: 'GGL',
    HWU_CLOUD: 'HW',
    EXOSCALE_CLOUD: 'EXO',
    ENTERPRISE_CLOUD: 'ENT',
}

CLOUD_PROVIDERS = [
    AZURE_CLOUD, GOOGLE_CLOUD, AWS_CLOUD, OPENSTACK_CLOUD,
    HWU_CLOUD, EXOSCALE_CLOUD, CSA_CLOUD, YANDEX_CLOUD,
    WORKSPACE_CLOUD, ENTERPRISE_CLOUD, AOS_CLOUD, VSPHERE_CLOUD,
    VMWARE_CLOUD, NUTANIX_CLOUD
]

# Application types
AWS_ROLE = 'AWS_ROLE'
AWS_CREDENTIALS = 'AWS_CREDENTIALS'
AZURE_CREDENTIALS = 'AZURE_CREDENTIALS'
AZURE_CERTIFICATE = 'AZURE_CERTIFICATE'
AZURE_ENROLMENT = 'AZURE_ENROLMENT'
GCP_COMPUTE_ACCOUNT = 'GCP_COMPUTE_ACCOUNT'
GCP_SERVICE_ACCOUNT = 'GCP_SERVICE_ACCOUNT'
# CUSTODIAN_TYPE = 'CUSTODIAN'  # declared in parents
# CUSTODIAN_LICENSES_TYPE = 'CUSTODIAN_LICENSES'
RIGHTSIZER_TYPE = 'RIGHTSIZER'
RABBITMQ_TYPE = 'RABBITMQ'
DEFECT_DOJO_TYPE = 'DEFECT_DOJO'

AVAILABLE_APPLICATION_TYPES = [
    AWS_ROLE, AWS_CREDENTIALS, AZURE_CREDENTIALS, AZURE_CERTIFICATE,
    AZURE_ENROLMENT,
    GCP_COMPUTE_ACCOUNT, GCP_SERVICE_ACCOUNT, CUSTODIAN_TYPE,
    CUSTODIAN_LICENSES_TYPE, RIGHTSIZER_TYPE,
    RABBITMQ_TYPE, DEFECT_DOJO_TYPE
]

# environment service
ENVS_TO_HIDE = set()
HIDDEN_ENV_PLACEHOLDER = '****'

# Tenant parent map types
TENANT_PARENT_MAP_BILLING_TYPE = 'BILLING'
TENANT_PARENT_MAP_MANAGEMENT_TYPE = 'MANAGEMENT'
TENANT_PARENT_MAP_CUSTODIAN_TYPE = CUSTODIAN_TYPE
TENANT_PARENT_MAP_CUSTODIAN_ACCESS_TYPE = CUSTODIAN_ACCESS_TYPE
TENANT_PARENT_MAP_CUSTODIAN_LICENSES_TYPE = CUSTODIAN_LICENSES_TYPE
TENANT_PARENT_MAP_RIGHTSIZER_TYPE = 'RIGHTSIZER'
TENANT_PARENT_MAP_RIGHTSIZER_LICENSES_TYPE = 'RIGHTSIZER_LICENSES'
TENANT_PARENT_MAP_SIEM_DEFECT_DOJO_TYPE = SIEM_DEFECT_DOJO_TYPE


ALLOWED_TENANT_PARENT_MAP_KEYS = (
    TENANT_PARENT_MAP_BILLING_TYPE,
    TENANT_PARENT_MAP_MANAGEMENT_TYPE,
    TENANT_PARENT_MAP_CUSTODIAN_TYPE,
    TENANT_PARENT_MAP_RIGHTSIZER_TYPE,
    TENANT_PARENT_MAP_RIGHTSIZER_LICENSES_TYPE,
    TENANT_PARENT_MAP_SIEM_DEFECT_DOJO_TYPE,
    TENANT_PARENT_MAP_CUSTODIAN_LICENSES_TYPE,
    TENANT_PARENT_MAP_CUSTODIAN_ACCESS_TYPE
)

DEFAULT_AWS_REGION = 'us-east-1'

# native cloud credentials envs
# AWS
ENV_AWS_ACCESS_KEY_ID = 'AWS_ACCESS_KEY_ID'
ENV_AWS_SECRET_ACCESS_KEY = 'AWS_SECRET_ACCESS_KEY'
ENV_AWS_SESSION_TOKEN = 'AWS_SESSION_TOKEN'
ENV_AWS_DEFAULT_REGION = 'AWS_DEFAULT_REGION'

# AZURE
ENV_AZURE_TENANT_ID = 'AZURE_TENANT_ID'
ENV_AZURE_SUBSCRIPTION_ID = 'AZURE_SUBSCRIPTION_ID'
ENV_AZURE_CLIENT_ID = 'AZURE_CLIENT_ID'
ENV_AZURE_CLIENT_SECRET = 'AZURE_CLIENT_SECRET'
ENV_AZURE_CLIENT_CERTIFICATE_PATH = 'AZURE_CLIENT_CERTIFICATE_PATH'
ENV_AZURE_CLIENT_CERTIFICATE_PASSWORD = 'AZURE_CLIENT_CERTIFICATE_PASSWORD'

# GOOGLE
ENV_GOOGLE_APPLICATION_CREDENTIALS = 'GOOGLE_APPLICATION_CREDENTIALS'
ENV_CLOUDSDK_CORE_PROJECT = 'CLOUDSDK_CORE_PROJECT'

JOB_SUCCESS_STATE = "SUCCESS"
JOB_FAIL_STATE = "FAIL"
JOB_RUNNING_STATE = "RUNNING"
